
/*******************************************************************************
*
* File contract.h
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef CONTRACT_H
#define CONTRACT_H

#ifndef DIAGRAMS_H
#include "diagrams.h"
#endif

#ifndef TREES_H
#include "trees.h"
#endif

typedef struct
{
   int nsm,nvm;
   int ns;
   int *nv;
   int **iv;
} vsets_t;

typedef struct
{
   int ntm,nvm;
   int nt,*lbl,*nv,*ns;
   int **iv,**ne;
   ltype_t *lt;
} src_legs_t;

/* CDGMS_C */
extern int cdgms(theory_t th,int order);
extern int nel_max(theory_t th,int order);
extern int no_of_cdgms(theory_t th,int order,int nel);
extern dlist_t *select_cdgms(theory_t th,int order,int nel);
extern void iR2D(theory_t th,int *ir,int *id);
extern void iD2R(theory_t th,int *id,int *ir);
extern void set_sfactor(theory_t th);

/* CONTRACT */
extern long init_contract(int nl,src_legs_t *sl);
extern long next_contract(line_t *lnl,long *nc);
extern void stop_contract(void);
extern void merge_ltrees(int nd,ltree_t **ltd,int nl,line_t *lnl,diagram_t *dm);
extern long mfact_ltrees(int m,int *n,int *idx);

/* LNLCON_C */
extern void init_vsets(vsets_t *vs);
extern void get_vsets(int nd,ltree_t **ltd,vsets_t *vs);
extern int lnlcon(vsets_t *vs,int nl,line_t *lnl);

/* SRC_LEGS_C */
extern void init_src_legs(src_legs_t *sl);
extern void get_src_legs(theory_t th,int nd,ltree_t **ltd,src_legs_t *sl);

/* TMAP_C */
extern int tmap(theory_t th,int order,int is);

#endif
